package com.example.notefullproyect.task.model

import androidx.room.Entity
import androidx.room.ForeignKey
import androidx.room.ForeignKey.Companion.CASCADE
import androidx.room.PrimaryKey
import com.example.notefullproyect.priority.model.Priority
import com.example.notefullproyect.progress.model.Progress
import com.example.notefullproyect.user.model.User

/**
 * Task entity with an autogenerated id.It has three foreignKeys userId, priorityId and progressId.
 * Contains  initial values to progressId and quantityTime.
 * Description property can be null.
 * @constructor userId, title, description, date, hour, priorityId.
 * @author Jessica Castillo
 */
@Entity(
    foreignKeys = [
        ForeignKey(
            entity = User::class,
            parentColumns = ["id"],
            childColumns = ["userId"],
            onDelete = CASCADE
        ),
        ForeignKey(
            entity = Priority::class,
            parentColumns = ["id"],
            childColumns = ["priorityId"],
            onDelete = CASCADE
        ),
        ForeignKey(
            entity = Progress::class,
            parentColumns = ["id"],
            childColumns = ["progressId"],
            onDelete = CASCADE
        )
    ]
)
data class Task(
    var userId: Int,
    var title: String,
    var description: String?,
    var date: String,
    var hour: String,
    var priorityId: Int

) {
    @PrimaryKey(autoGenerate = true)
    var id: Int = 0
    var progressId: Int = 1
    var quantityTime: Int = 0
}




